#include "Cyton_Esp12Data.h"
#include "usart.h"	
#include <string.h>
#include "delay.h"       
#include "led.h"       
#include "key.h"
#include "Timer.h"
#include "ADS129x.h"
#include "ESP8266.h"
#include "cJSON.h"

#include "myQueue.h"
#include "cyton_cmd_pub.h"


typedef struct stCytron_DevSeting {
    int iRate;
    uint32_t uiSaveSdCardMs;
    uint8_t aucDeviceNum;
    uint8_t aucStreamStat;
} CYTON_DEVSETING_T;

static int g_iOpenguiPort = -1;
static uint8_t g_szOpenguiIP[16] = {0};
static int g_iOpenguiFd = 4;
static uint8_t g_iOepnguiConnnectStat = 0;
static CYTON_DEVSETING_T g_stCytron_DevSeting;

#if 0
static int Ctron_atoi(uint8_t *szData, int iLen)
{
    //0,11:123456711
    uint8_t szTmp[4] = {0};

    if (iLen > 4) {
        return -1;
    }

    strncpy(szTmp, szData, iLen);
    return atoi(szTmp);
}


static int Ctron_GetDataLen(uint8_t *szData, int iLen)
{
    /* 9:1234567 */
    uint8_t iColon = 0;
    uint8_t szTmp[4] = {0};

    while (iColon < 5) {
        if(*(szData + iColon) == ':') {
            iColon ++;
            break;
        }

        iColon ++;
    }

    if (iColon <= 4) {
        strncpy(szTmp, szData, iColon);
    } else {
        return -1;
    }

    return atoi(szTmp);
}

static int ctron_GetRate(uint8_t *szData, int iLen)
{
    uint8_t *pszIndex = NULL;

    pszIndex = strstr(szData, "~");
    if (NULL != pszIndex) {
        return Ctron_atoi(pszIndex + 1, 1);
    }

    return -1;    
}

static int ctron_Esp12Data_PraseTcpJson(int iFD, uint8_t *szData, int iLen)
{
    //{"connected":true,"delimiter":true,"ip":"192.168.4.2","output":"raw","port":6677,"latency":10000}
    cJSON *cjson_data;
    cJSON *cjson_str;

    uint8_t *pszIndex = 0;
    
    pszIndex = strstr(szData, "{");
    if (NULL == pszIndex) {
        ESP8266_DEBUG("\r\ntcp json prase failed1111111111: %s\n", szData);
        return -1;
    }

    cjson_data = cJSON_Parse(pszIndex);
    if (cjson_data) {
	    cjson_str = cJSON_GetObjectItem(cjson_data,"ip");
	    if (cjson_str) {
            sprintf(g_szOpenguiIP, "%s", cjson_str->valuestring);
            ESP8266_DEBUG("TCP Json g_szOpenguiIP %s\n", g_szOpenguiIP);
        }

        cjson_str = cJSON_GetObjectItem(cjson_data,"port");
	    if (cjson_str) {
            g_iOpenguiPort = cjson_str->valueint;
            ESP8266_DEBUG("TCP Json g_szOpengui port %d\n", g_iOpenguiPort);
        }

        cjson_str = cJSON_GetObjectItem(cjson_data,"command");
	    if (cjson_str) {
            g_stCytron_DevSeting.aucRate = ctron_GetRate(cjson_str->valuestring, strlen(cjson_str->valuestring));
            ESP8266_DEBUG("g_stCytron_DevSeting.aucRate %d\n", g_stCytron_DevSeting.aucRate);
        }

	    cJSON_Delete(cjson_data);

        return 0;
    }

    ESP8266_DEBUG("\r\ntcp json prase failed: %s\n", szData);

    return -1;
}

//;
//const char *szBoardRspJson = 
const char *szBoardRsp = "HTTP/1.0 200 Ok\r\n"
    "Content-Type: text/json\r\n"
    "Access-Control-Allow-Origin: *\r\n"
    "Content-Length: 96\r\n"
    "Connection: close\r\n"
    "\r\n"
    "{\"board_connected\":true,\"board_type\":\"cyton\",\"num_channels\":8,\"gains\":[24,24,24,24,24,24,24,24]}";

const char *szTcpRsp = "HTTP/1.0 200 Ok\r\n"
    "Content-Type: text/json\r\n"
    "Access-Control-Allow-Origin: *\r\n"
    "Content-Length: 97\r\n"
    "Connection: close\r\n"
    "\r\n"
    "{\"connected\":true,\"delimiter\":true,\"ip\":\"192.168.4.2\",\"output\":\"raw\",\"port\":6677,\"latency\":10000}";

const char *szCommandHz = "HTTP/1.0 200 Ok\r\n"
    "Content-Type: text/json\r\n"
    "Access-Control-Allow-Origin: *\r\n"
    "Content-Length: 32\r\n"
    "Connection: close\r\n"
    "\r\n"
    "Success: Sample rate is 1000Hz";

const char *szStreamStartRsp = "HTTP/1.0 200 Ok\r\n"
    "Content-Type: text/json\r\n"
    "Access-Control-Allow-Origin: *\r\n"
    "Content-Length: 16\r\n"
    "Connection: close\r\n"
    "\r\n"
    "Stream started\r\n";

const char *szStreamStopRsp = "HTTP/1.0 200 Ok\r\n"
    "Content-Type: text/json\r\n"
    "Access-Control-Allow-Origin: *\r\n"
    "Content-Length: 16\r\n"
    "Connection: close\r\n"
    "\r\n"
    "Stream stopped\r\n";

//{"connected":true,"delimiter":true,"ip":"192.168.4.2","output":"raw","port":6677,"latency":10000}
void Ctron_Esp12Data_Recv(int iFD, uint8_t *szData, int iLen)
{
    int iRet = -1;
    /* GET /board HTTP/1.0
    Host: 192.168.4.1:80 
    rsp:
    HTTP/1.0 200 Ok\r\n
    Content-Type: text/json\r\n
    Access-Control-Allow-Origin: *\r\n
    Content-Length: 96\r\n
    Connection: close\r\n
    \r\n
    {"board_connected":true,"board_type":"cyton","num_channels":8,"gains":[24,24,24,24,24,24,24,24]}
    */

    if (strstr(szData, "GET /board")) {
        ESP8266_DEBUG("Board rsp length %d\n", strlen(szBoardRsp));
        Ctron_Esp12Data_Send(iFD, (uint8_t *)szBoardRsp, strlen(szBoardRsp), 1);

    } else if (strstr(szData, "\"port\":6677")) {
        iRet = ctron_Esp12Data_PraseTcpJson(iFD, (uint8_t *)szData, iLen);
        if (iRet == 0) {
            ESP8266_DEBUG("tcp start connect %s:%d\n", g_szOpenguiIP, g_iOpenguiPort);
            ESP8266_SendCmd("AT+CIPSTART=4,\"TCP\",\"192.168.4.2\",6677\r\n", "OK", 1000);
            ESP8266_DEBUG("tcp start rsp\n");
            Ctron_Esp12Data_Send(iFD, (uint8_t *)szTcpRsp, strlen(szTcpRsp), 1);
        }

	} else if (strstr(szData, "\"command\"")) {
        iRet = ctron_Esp12Data_PraseTcpJson(iFD, (uint8_t *)szData, iLen);
        if (iRet == 0) {
            ESP8266_DEBUG("command start rsp\n");
            Ctron_Esp12Data_Send(iFD, (uint8_t *)szCommandHz, strlen(szCommandHz), 1);
        } else {

        }

    } else if (strstr(szData, "/stream/start")) {
        ESP8266_DEBUG("stream start rsp\n");
        g_stCytron_DevSeting.aucStreamStat = 1;
        Ctron_Esp12Data_Send(iFD, (uint8_t *)szStreamStartRsp, strlen(szStreamStartRsp), 1);
        CytonProcess_TimerCollStart(1000);
    } else if (strstr(szData, "/stream/stop")) {
        ESP8266_DEBUG("stream stop rsp\n");
        g_stCytron_DevSeting.aucStreamStat = 0;
        CytonProcess_TimerCollStop();
        Ctron_Esp12Data_Send(iFD, (uint8_t *)szStreamStopRsp, strlen(szStreamStopRsp), 1);
    } else {
        ESP8266_DEBUG("Prase failed\n");
    }
}

void Ctron_Esp12Data_Send(int iFD, uint8_t *szData, int iLen, int iClose)
{
}


/* +IPD,0,9:1234567 */
void Ctron_Esp12Data_Loop()
{
    uint8_t *pszIndex = NULL;
    uint8_t *pszData = NULL;
    int iFd = -1;
    int iLen = -1;

    pszIndex = strstr(USART2_RX_BUF, "+IPD,");
    if (NULL != pszIndex) {
        iFd = Ctron_atoi(pszIndex + 5, 1);
        iLen = Ctron_GetDataLen(pszIndex + 7, USART2_RX_LEN - 7);
        ESP8266_DEBUG("Ctron_Esp12Data_Loop fd [%d](lengh=%d): %s\r\n", iFd, iLen, ESP8266_RX_BUF);

        pszIndex = strstr(USART2_RX_BUF, ":");
        if (iFd >= 0) {
            Ctron_Esp12Data_Recv(iFd, pszIndex + 1, iLen);
        }
        ESP8266_CLEAR();
    }
}

int CytonEsp12_DataGetReportFd()
{
    return g_iOpenguiFd;
}

#endif 

int CytonEsp12_StreamStat()
{
    return g_stCytron_DevSeting.aucStreamStat;
}

void CytonEsp12_SetStreamStat(int iStat)
{
    g_stCytron_DevSeting.aucStreamStat = iStat;
}

uint8_t CytonEsp12_GetCurrentRateCmd()
{
    int iRate = g_stCytron_DevSeting.iRate;
    uint8_t aucRet = 0;
    /*
        ADS129X_CMD_250HZ = 0,
	ADS129X_CMD_500HZ,
	ADS129X_CMD_1000HZ,
	ADS129X_CMD_2000HZ,
	ADS129X_CMD_4000HZ,
	ADS129X_CMD_8000HZ,
    */

    if (250 == iRate) {
        aucRet = ADS129X_CMD_250HZ;
    } else if (500 == iRate) {
        aucRet = ADS129X_CMD_500HZ;
    } else if (1000 == iRate) {
        aucRet = ADS129X_CMD_1000HZ;
    } else if (2000 == iRate) {
        aucRet = ADS129X_CMD_2000HZ;
    } else if (4000 == iRate) {
        aucRet = ADS129X_CMD_4000HZ;
    } else if (8000 == iRate) {
        aucRet = ADS129X_CMD_8000HZ;
    }

    return aucRet;
}


#define toNet32(A)   ((( (unsigned int)(A) & 0xff000000) >> 24)|(( (unsigned int)(A) & 0x00ff0000) >> 8)|(( (unsigned int)(A) & 0x0000ff00) << 8)|(( (unsigned int)(A) & 0x000000ff) << 24)) 

int g_iHz = 0;

void CytonEsp12_PraseLoop()
{
	//ESP8266_RX_BUF, ESP8266_RX_LEN,//
	CYTON_CMD_INFO_T *pstCmdInfo = NULL;
	char *pszIndex = ESP8266_RX_BUF;
	int iLen = ESP8266_RX_LEN;

	while (iLen > 0) {
		if (iLen >= sizeof(CYTON_CMD_INFO_T)) {
			pstCmdInfo = (CYTON_CMD_INFO_T *) pszIndex;
			if (CYTON_CMD_HEAD == toNet32(pstCmdInfo->uiHead)) {
				ESP8266_DEBUG("Find cmd %08x\r\n", toNet32(pstCmdInfo->iType));
				ESP8266_DEBUG("Find p1 %08x\r\n", toNet32(pstCmdInfo->uiParam1));
				if (toNet32(pstCmdInfo->iType) == CYTON_CMD_HZ) {
					g_stCytron_DevSeting.iRate = toNet32(pstCmdInfo->uiParam1);
					ESP8266_DEBUG("g_iHz %d\r\n", g_stCytron_DevSeting.iRate);
                } else if (toNet32(pstCmdInfo->iType) == CYTON_CMD_SD) {
                    g_stCytron_DevSeting.uiSaveSdCardMs = toNet32(pstCmdInfo->uiParam1) * 1000;
                    ESP8266_DEBUG("Save SD command %d \r\n", g_stCytron_DevSeting.uiSaveSdCardMs);
                    g_stCytron_DevSeting.iRate = 250;
                } else if (toNet32(pstCmdInfo->iType) == CYTON_CMD_DEVICE_CONN) {
                    g_stCytron_DevSeting.aucDeviceNum = toNet32(pstCmdInfo->uiParam1);
                    ESP8266_DEBUG("Current Device connect number %d S\r\n", g_stCytron_DevSeting.aucDeviceNum);
				} else if (toNet32(pstCmdInfo->iType) == CYTON_CMD_START) {
					ESP8266_DEBUG("Start collector %d Hz\r\n", g_stCytron_DevSeting.iRate);
                    if (0 == CytonEsp12_StreamStat()) {
                        if (g_stCytron_DevSeting.uiSaveSdCardMs > 0) {
                            CytonSD_Start();
                        }
					    
					    ADS129x_ReInit(1, CytonEsp12_GetCurrentRateCmd());	
					    CytonEsp12_SetStreamStat(1);
                    } else {
                        ESP8266_DEBUG("Already start collector %d Hz, ignore\r\n", g_stCytron_DevSeting.iRate);
                    }
				} else if (toNet32(pstCmdInfo->iType) == CYTON_CMD_STOP) {
					ESP8266_DEBUG("Stop collector\r\n");
					CytonEsp12_SetStreamStat(0);
					ADS129x_Stop();
                    if (g_stCytron_DevSeting.uiSaveSdCardMs > 0) {
                        CytonSD_Stop();
                    }
				}

				ESP8266_CLEAR();
				break;
			} 
		} else {
			break;
		}

		pszIndex ++;
		iLen --;
	}

	//ESP8266_CLEAR();
}


uint32_t CytonEsp12_GetSDSaveMs()
{
    return g_stCytron_DevSeting.uiSaveSdCardMs;
}

uint32_t CytonEsp12_KeySaveSD()
{
    if (0 == CytonEsp12_StreamStat()) {
        g_stCytron_DevSeting.uiSaveSdCardMs = 300000;
        g_stCytron_DevSeting.iRate = 250;
        CytonSD_Start();
        ADS129x_ReInit(1, CytonEsp12_GetCurrentRateCmd());	
        CytonEsp12_SetStreamStat(1);
        ESP8266_DEBUG("Button start collector %d Hz, ignore\r\n", g_stCytron_DevSeting.iRate);
    } else {
        ESP8266_DEBUG("Button Stop collector\r\n");
		CytonEsp12_SetStreamStat(0);
		ADS129x_Stop();
        if (g_stCytron_DevSeting.uiSaveSdCardMs > 0) {
            CytonSD_Stop();
        }
    }
}


